#!/bin/bash
#
#	Copyright © 2008
#	Gebr. Märklin & Cie GmbH
#	Abteilung TEE
#
#	Starte das Programm cs2.arm mit Vorbereitungen
#
#	26.01.08 by Andreas Kielkopf
#	15.06.09
#	19.05.10 braser-Erweiterung eingebaut
#	22.11.10 startup.sh
#	16.03.13 Screensaver ausschalten

export PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/bin"
export LD_LIBRARY_PATH="/usr/local/lib:/usr/local/Trolltech/QtopiaCore-4.3.4-arm/lib:/usr/local/Trolltech/QtopiaCore-4.3.3-arm/lib"
export TSLIB_CONFFILE="/etc/ts.conf"
export erg="0"

. startup.sh

# Screensaver ausschalten
echo -e '\033[9;0]' > /dev/tty1
# Schreibe beim ersten Start das Scratchpad des GFP
SP="/root/scratchpad"
if [ -f $SP.txt ] ;then $SP.arm 127.0.0.1 -y $SP.txt -s -qws ;rm $SP.txt ;fi

braser.sh
if [ -d /tmp/cs2 ] ;then cd /tmp/cs2;else cd /home/cs2;fi

# starte den Cleanup-loop
cleanup_loop.sh &
/usr/local/hw/kernel/kernel_update.sh detect &

while true
do
	# verhindere daß das Gateway blockiert
	killall gateway.arm
	if [ -e ./cs2.arm ]
	then
		./cs2.arm 10.100.21.254 -qws -style plastique
	else
		/home/cs2/cs2.arm 10.100.21.254 -qws -style plastique
	fi
	erg=$?
	nand-disk_on.sh
	echo "Abbruchcode=$erg"
	echo -e '\033[9;0]' > /dev/tty1
	# Daten sichern (ohne symlinks)  
	echo "GUI-Abbruch (`date`) mit Code $erg" >> /tmp/cs2.log
	braser.sh
	sync
    case $erg in
        8 ) echo "(8)Update-neu ausführen"
            /home/cs2/upd.arm
            updrc=$?
            if [ "$updrc" == "1" ]
            then
		reboot.sh
                echo "exit nach reboot"
                exit 0
            fi
            echo "weiter nach update-neu"
            ;;
        7 ) echo "(7)Update ausführen"
            update.sh  > /tmp/update.log
            update_cleanup.sh >> /tmp/update.log
            echo "weiter nach update"
            ;;
        6 ) echo "(6)exit nach Fehlercode 6"
            exit 0
            ;;
        5 ) echo "(5)Heartbeat anschalten"
            heartbeat_on.sh
            echo "Heartbeat angeschaltet"
            ;;
        4 ) echo "(4)Reboot ausführen"
            reboot.sh
            echo "exit nach reboot"
            exit 0
            ;;
        3 ) echo "(3)Calibrate ausführen"
            calibrate.sh
            echo "weiter nach calibrate"
            ;;
        2 ) echo "(2)Shutdown ausführen"
            break
            ;;
        9 ) echo "(8)DHCP lease holen"
            dhcpcd -n eth0
            ;;
        14 ) echo "(14)Betatest-Script"
            mount_stick.sh
        	 if [ -e /tmplog/stick/betatest.sh ];then /tmplog/stick/betatest.sh;fi
        	 ;;  
        13 ) echo "(13)Betatest-Update"
        	export version=testing
            update_rsync.sh 0 5 11 60 > /tmp/update.log
            update_cleanup.sh >> /tmp/update.log
            unset version
            echo "weiter nach Betatest-update"
            ;;
            # 15= internes Betatest-Update
        0 ) echo "(0)Fehlerhafter Exit-Code 0"
            /home/cs2/gfpstop.arm
            heartbeat_on.sh
            echo "Versuche Restart in 5 Sekunden"
            sleep 5
            ;;
        1 ) echo "(1)Programm startet sofort durch"
            ;;
       99 ) echo "(99)Starte Soundconfig-Programm"
       		{
       		rm -f updstart.txt
       		if [ -e ./sound.arm ];then ls -la
            	./sound.arm -qws
       		else echo "gehen sie über LOS"
    		 	/home/cs2/sound.arm -qws
    		fi
    		echo "sound importieren"
    		sound_sign.sh
    		rm -f sndstart.txt
			} >> /tmp/soundtool.log
            ;;
        * ) echo "unbekannter Fehler $erg"
            /home/cs2/gfpstop.arm
            heartbeat_on.sh
            echo "Versuche Restart in 30 Sekunden"
            sleep 30
            ;;
    esac
	# Screen einschalten
	echo 0 > /sys/class/graphics/fb0/blank
    nand-disk_on.sh off 15 &
done
# sauber Herrunterfahren
nand-disk_on.sh
sync
shutdown.sh
